package intsort;

public class Sort12 implements Sort {

  // merge a1[l..m[ and a1[m..r[ into a2[l..r[
  static void merge(int[] a1, int[] a2, int l, int m, int r) {
    int i = l, j = m;
    for (int k = l; k < r; k++)
      if (i < m && (j == r || a1[i] <= a1[j]))
        a2[k] = a1[i++];
      else
        a2[k] = a1[j++];
  }

  // recursive, top-down mergesort
  static void mergesortrec(int[] a, int[] tmp, int l, int r) {
    if (l >= r-1) return;
    int m = l + (r - l) / 2;
    mergesortrec(a, tmp, l, m-1);
    mergesortrec(a, tmp, m, r);
    if (a[m-1] <= a[m]) return; // optim
    for (int i = l; i < r; i++) tmp[i] = a[i];
    merge(tmp, a, l, m, r);
  }

  public void sort(int[] a) {
    mergesortrec(a, new int[a.length], 0, a.length);
  }

}
